package ttt.model;
import java.awt.*;
import java.util.*;

/** A computer player whose moves are governed by a strategy object. */
public class ComputerPlayer extends Player implements Observer {
    private Strategy strategy;
    
    public ComputerPlayer(String name, String letter, TTTGame game,
            Strategy strategy) {
        super(name, letter);
        this.strategy = strategy;
        
        // game.addObserver(this);
    }
    
    /** Called by the observable game model. */
    public void update(Observable o, Object args) {
        TTTGame game = (TTTGame) o;
        if (!game.isGameOver() && game.getCurrentPlayer() == this) {
            Point move = strategy.getMove(game);
            game.play(move.x, move.y);
        }
    }
}
